function [est_xi, S_P] = estStepSRCF(est_xi, z, S_P, F, Bd, G, S_Q, H, S_R)
%ESTSTEPSRCF Summary of this function goes here
%   Detailed explanation goes here

n = size(F, 1);
% Build the pre-array
A=[(F * S_P)';
   (G * S_Q)'];
% Calculate QA=R and find the post-array
[~, RR] = qr(A);

% Extract results from the post-array
S_P = RR(1:n, 1:n)';

% Calculate the state estimate
est_xi = F * est_xi + Bd ; % x  - Predicted state estimate

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
m = size(S_R,1);
 
% Build the pre-array
A = [S_R'       zeros(m,n);
     S_P' * H'  S_P'];
% Calculate QA=R and find the post-array
RR=qr(A);

% Extract results from the post-array
S_Re = RR(1:m, 1:m)';
S_P = RR(m+1:m+n, m+1:m+n)';
     
bar_Kp = RR(1:m, m+1:m+n)';

% Calculate the state estimate
bar_e = S_Re \ (z - H * est_xi);
est_xi  = est_xi   + bar_Kp * bar_e; % x  - Filtered state estimate
