function [est_xi, U_P, D_P] = estStepUD(est_xi, z, U_P, D_P, F, B, G, U_Q, D_Q, H, U_R, D_R)
%ESTSTEPUD Summary of this function goes here
%   Detailed explanation goes here

m = size(U_R, 1);
n = size(U_P, 1);
q = size(U_Q, 1);

% Build  {A,Dw} pre-arrays
A = [G * U_Q     F * U_P  zeros(n, m);
     zeros(m,q)  H*U_P    U_R];

Dw = diag([diag(D_Q); diag(D_P); diag(D_R)]);

% Calculate MWGS and find {U,Db} post-arrays
[U, Db] = MWGS_UD(A', Dw);

% Extract results from the post-arrays
U_P = U(1:n, 1:n);
U_Re = U(n+1:n+m, n+1:n+m);
U_KpRe = U(1:n, n+1:n+m);
D_P = Db(1:n, 1:n);
 
% Calculate the state estimate
bar_e = U_Re \ (z - H * est_xi);
est_xi = F * est_xi + B + U_KpRe * bar_e; % x  - Filtered state estimate
